Description

It just took me very long time to figure why I can't change members on a project, until I finally, by accident, thought, I could try turning

on javascript for that page (which is diabled by default).

I consider applications not working without javascript quite bad (

http://kevinlamping.com/web-tutorials/ten-reasons-to-write-degradable-javascript.html) , but not even letting the user know that app

will not work 100% with javascript disabled is very annoying and can lead - as happened her - to a lot of wasted time while trying to

find the problem.

Associated revisions

Revision 3483 - 2010-02-24 22:23 - Jean-Philippe Lang

Fixed: changing user/roles of project member not possible without javascript (#4852)

History

#1 - 2010-02-16 14:59 - Henning Sprang

Same with deleting an issue.

Here, without javaScript, I get an error page saying "403 - You are not authorized to access this page" - which rather lead me to review my redmine

installation for errors with fastcgi etc.

With javascript, I just get a question if I really want to delete.

#2 - 2010-02-17 01:13 - Jeffrey Jones

I think a counter-argument would be that this is not an ordinary website but a web-application. Every web application of reasonable complexity I have

come across requires JavaScript for full functionality.

To me Web-apps and Websites serve different functions and should have different expectations. To answer the list:

10. Not an argument against JS per se but against idiots that use JS for validation without any server-side validation.

9. Most of these problems are handled by rails itself (The maintenance side anyway).

8. Redmine is not designed to be used on mobile phones. There are issues raised about this and some work may be done tailoring it.

7. A very weak argument I feel generally and kind of non-sensical, hard to explain why (sorry).

6. Anyone editing Redmine's JS files should know what they are doing because it is not an everyday event.

5. Redmine is likely to be an internal company application and exempt from firewall blocks, if it is external then users would probably get the site

exempted because it would be used for a business purpose.

4. Anti-JS plugins like noscript make it very very easy to whitelist certain sites.

3. Valid

2. This is something to do with pop-ups, not general JS

1. None of the basic display functions require JS so search engines can still see what they need (and are allowed) to see.

Most of these points are valid'ish for general, commercial, revenue generating websites. I don't think you will find many people running RedMine for

that purpose.

Note that I do not speak for the RedMine team and they may disagree with me and implement these functions, I am just another user chiming in.

I would rather they spend their time implementing features than making sure the site works without JS.

#3 - 2010-02-17 13:58 - Benjamin Baroukh

+1 This is a web application. Firstly the user experience will be awful without it because everything will be static. Moreover, as said previously it will

consume an enormous amount of time to achieve no Javascript and this time would be much more valuable in developing the application.
#4 - 2010-02-17 18:34 - Henning Sprang

Jeffrey, don't get me wrong, I totally agree that JavaScript is nice to havce to improve Usability in a web application.

But! Having some functionality not working, showing strange behaviour and NOT letting the user know that the reason for this is the lack of

JavaScript, is not really nice.

Jeffrey Jones wrote:

I think a counter-argument would be that this is not an ordinary website but a web-application.

 And the page doesn't say it's only about website and not for web apps :)

Every web application of reasonable complexity I have come across requires JavaScript for full functionality.

 But also, many web applications have an extra operating mode that runs without JavaScript - properly, and fully.

To me Web-apps and Websites serve different functions and should have different expectations. To answer the list:

 I'd agree with you in some points and disagree in others, but it's probably too far out of scope to discuss every argument in the list here. (I probably

shouldn't have posted the link here)

You might be right, the redmine developers should better spend time making the software better.

(on the other hand, one should think about how much work it is to change these two places where i found the problem)

Anyway, if you define that an application does only run properly with JavaScript enabled, you have to tell the user it is so.

so, if not doing the app properly degradabale, a huge warning on the login page, that the user has JavaScript disabled, and that some things won't

work properly, is a good thing to do and not too much work.

#5 - 2010-02-17 18:39 - Henning Sprang

Benjamin Baroukh wrote:

+1 This is a web application. Firstly the user experience will be awful without it because everything will be static.

 I'm not talking about throwing all JavaScript out.

The concept of being degradable is to have both and adapt to the capabilities of the client.

Properly done, a JavaScript enabled user will have all the nice things that enhance usability, while others have a bit less usability(e.g. extra loading of

a page whereas the JavaScript user will get stuff reloaded in the background with Ajax), but still all functionality.

Moreover, as said previously it will consume an enormous amount of time to achieve no Javascript and this time would be much more valuable

in developing the application.

 I cannot tell defintely, but I cannot imagine it will be such an enormous amount of work to get the two functions mentioned in this ticket working with

JavaScript disabled - all the rest of the application already works with not problems withput JavaScript.

#6 - 2010-02-24 22:27 - Jean-Philippe Lang

- Status changed from New to Closed

- Target version set to 1.0.0 (RC)

- Resolution set to Fixed

This is fixed in r3483.

Without javascript, the form looks ugly but you are now able to edit member roles. To remove a member, uncheck all its roles.
